//
//  VerificationCodeLoginView.m
//  Luba
//
//  Created by 张浩 on 2018/4/27.
//  Copyright © 2018年 sjl. All rights reserved.
//

#import "VerificationCodeLoginView.h"
#import "UIButton+countDown.h"
#import "UUID.h"
#import "login_common.h"
@interface VerificationCodeLoginView()
@property (nonatomic , strong)UIView *phoneView;
@property (nonatomic , strong)UIView *vcView;
@end
@implementation VerificationCodeLoginView
-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        [self addSubview:self.phoneView];
        [self addSubview:self.vcView];
        [self addSubview:self.changeBtn];
        [self.phoneView addSubview:self.phoneTF];
        [self.phoneView addSubview:self.sendVCBtn];
        UIView *line1 = [[UIView alloc]init];
        line1.backgroundColor = [UIColor groupTableViewBackgroundColor];
        [self.phoneView addSubview:line1];
        
        [self.vcView addSubview:self.vcTF];
        UIView *line2 = [[UIView alloc]init];
        line2.backgroundColor = [UIColor groupTableViewBackgroundColor];
        [self.vcView addSubview:line2];
        
        [self.phoneView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.top.right.equalTo(self);
            make.height.equalTo(@60);
        }];
        [self.phoneTF mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.phoneView.mas_left).offset(30);
            make.right.equalTo(self.sendVCBtn.mas_left).offset(-10);
            make.centerY.equalTo(self.phoneView.mas_centerY);
            make.height.equalTo(@30);
        }];
        [self.sendVCBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.phoneView.mas_right).offset(-30);
            make.centerY.equalTo(self.phoneView.mas_centerY);
            make.height.equalTo(@30);
            make.width.equalTo(@80);
        }];
        [line1 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.phoneView.mas_left).offset(30);
            make.right.equalTo(self.phoneView.mas_right).offset(-30);            make.bottom.equalTo(self.phoneView.mas_bottom).offset(-1);
            make.height.equalTo(@1);
        }];
        
        [self.vcView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.right.equalTo(self);
            make.top.equalTo(self.phoneView.mas_bottom);
            make.height.equalTo(@60);
        }];
        [self.vcTF mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.vcView.mas_left).offset(30);
            make.right.equalTo(self.vcView.mas_right).offset(-30);
            make.centerY.equalTo(self.vcView.mas_centerY);
            make.height.equalTo(@30);
        }];
        
        [line2 mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self.vcView.mas_left).offset(30);
            make.right.equalTo(self.vcView.mas_right).offset(-30);             make.bottom.equalTo(self.vcView.mas_bottom).offset(-1);
            make.height.equalTo(@1);
        }];
        [self.changeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(self.mas_right).offset(-30);
            make.top.equalTo(self.vcView.mas_bottom).offset(5);
            make.height.equalTo(@30);
            make.width.equalTo(@60);
        }];
    }
    return self;
}
- (void)countTextLength:(UITextField *)textField {
    if (textField.text.length >11) {
        [MBManager showBriefAlert:@"手机号长度超出"];
        textField.text = [textField.text substringToIndex:11];
    }
}
-(IBAction)sendVCBtnClick:(id)sender{
    if (![self.phoneTF.text isMobile]) {
        [MBManager showBriefAlert:@"请输入正确的手机号"];
        return;
    }
    [self.phoneTF resignFirstResponder];
    [self loadverifyCodeData];
    self.sendVCBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentCenter;
    self.sendVCBtn.backgroundColor = [UIColor colorWithHexString:@"#EF6050"];
    [self.sendVCBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self.sendVCBtn startWithTime:59 title:@"发送验证码" countDownTitle:@"重新发送(" mbColor:[UIColor whiteColor] mwColor:[UIColor colorWithHexString:@"#16A196"] mwPosition:UIControlContentHorizontalAlignmentRight bColor:[UIColor colorWithHexString:@"#EF6050"] wColor:[UIColor whiteColor] wPosition:UIControlContentHorizontalAlignmentCenter withBlock:^(BOOL btnused) {
        self.sendVCBtn.userInteractionEnabled = btnused;
    }];
}

- (void)loadverifyCodeData {
    NSMutableDictionary *params = [NSMutableDictionary dictionary];
    params[@"imei"] = [UUID getUUID];
    params[@"tel"] = self.phoneTF.text;
    params[@"c_s"] = C_S;
    params[@"type"] = LOGININCODE;
    NSString *key = [[NSString stringWithFormat:@"%@soooner1802",self.phoneTF.text] md5Str];
    params[@"key"] = key;
    [J_AFNetWorkManager POST:API_GETVERIFYCODE params:params success:^(NSURLSessionDataTask *task, id responseObject) {
        if ([responseObject[@"rc"] isEqual:@"0"]) {
            [MBManager showBriefAlert:@"验证码获取成功"];
        }else{
            [MBManager showBriefAlert:responseObject[@"des"]];
        }
    } fail:^(NSURLSessionDataTask *task, NSError *error) {


    }];
}
-(UIView *)phoneView{
    if (_phoneView == nil) {
        _phoneView = [[UIView alloc]init];
        _phoneView.backgroundColor = [UIColor whiteColor];
    }
    return _phoneView;
}
-(UIView *)vcView{
    if (_vcView == nil) {
        _vcView = [[UIView alloc]init];
        _vcView.backgroundColor = [UIColor whiteColor];
    }
    return _vcView;
}
-(UITextField *)phoneTF{
    if (_phoneTF == nil) {
        _phoneTF = [[UITextField alloc]init];
        _phoneTF.textColor = [UIColor colorWithHexString:@"#333333"];
        _phoneTF.font = [UIFont systemFontOfSize:25];
        _phoneTF.placeholder = @"手机号";
        [_phoneTF setValue:[UIColor colorWithHexString:@"#C3C3C3"] forKeyPath:@"_placeholderLabel.textColor"];
        [_phoneTF addTarget:self action:@selector(countTextLength:) forControlEvents:UIControlEventEditingChanged];
        _phoneTF.keyboardType = UIKeyboardTypePhonePad;
    }
    return _phoneTF;
}
-(UITextField *)vcTF{
    if (_vcTF == nil) {
        _vcTF = [[UITextField alloc]init];
        _vcTF.textColor = [UIColor colorWithHexString:@"#333333"];
        _vcTF.font = [UIFont systemFontOfSize:25];
        _vcTF.placeholder = @"输入收到的验证码";
        [_vcTF setValue:[UIColor colorWithHexString:@"#C3C3C3"] forKeyPath:@"_placeholderLabel.textColor"];
        _vcTF.keyboardType = UIKeyboardTypeNumberPad;
    }
    return _vcTF;
}
-(UIButton *)changeBtn{
    if (_changeBtn == nil) {
        _changeBtn = [[UIButton alloc]init];
        [_changeBtn setTitleColor:[UIColor colorWithHexString:@"#16A196"] forState:UIControlStateNormal];
        _changeBtn.titleLabel.font = [UIFont systemFontOfSize:12];
        [_changeBtn setTitle:@"密码登录" forState:UIControlStateNormal];
        _changeBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    }
    return _changeBtn;
}
-(UIButton *)sendVCBtn{
    if (_sendVCBtn == nil) {
        _sendVCBtn = [[UIButton alloc]init];
        [_sendVCBtn setTitle:@"发送验证码" forState:UIControlStateNormal];
        [_sendVCBtn addTarget:self action:@selector(sendVCBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        [_sendVCBtn setTitleColor:[UIColor colorWithHexString:@"#16A196"] forState:UIControlStateNormal];
        _sendVCBtn.titleLabel.font = [UIFont systemFontOfSize:12];
        _sendVCBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
        _sendVCBtn.layer.masksToBounds = YES;
        _sendVCBtn.layer.cornerRadius = 2;
    }
    return _sendVCBtn;
}


@end
